<?php
if (!class_exists('crosssync_Post_Meta')) {

    class crosssync_Post_Meta
    {

        function __construct()
        {

            add_action('admin_init', array($this, 'register_meta_settings'));

            add_action('save_post', array($this, 'save_meta_fields'));
        }

        function register_meta_settings()
        {
            global $crosssync_settings;
            add_meta_box(
                'crosssync_websites',
                __('Select Websites', 'crosssync'),
                array($this, 'print_meta_fields'),
                $crosssync_settings->crosssync_get_post_types(),
                'side',
                'default'
            );
        }

        public function print_meta_fields()
        {
            global $wpdb, $crosssync_settings, $post;
            $general_option = $crosssync_settings->crosssync_get_settings_func();

            echo '<div class="drop_meta_container">';
            echo '<div class="drop_meta_item fullwidth">';
            echo '<div class="inner_meta">';

            if (!empty($general_option) && isset($general_option['crosssync_host_name']) && !empty($general_option['crosssync_host_name'])) {
                $crosssync_website = get_post_meta($post->ID, 'crosssync_website', false);
                $old_meta = (isset($crosssync_website['0']) && !empty($crosssync_website['0'])) ? $crosssync_website['0'] : array();
                $crosssync_selected = (isset($general_option['crosssync_selected']) && !empty($general_option['crosssync_selected'])) ? $general_option['crosssync_selected'] : array();

                foreach ($general_option['crosssync_host_name'] as $crosssync_key => $crosssync_value) {
                    $checked = (in_array($crosssync_value, $old_meta)) ? 'checked="checked"' : '';
                    $checked = (isset($crosssync_selected[$crosssync_key]) && !empty($crosssync_selected[$crosssync_key])) ? 'checked="checked"' : '';

                    echo '<input type="checkbox" name="crosssync_website[]" id="crosssync_website_' . esc_attr($crosssync_key) . '" value="' . esc_attr($crosssync_value) . '" ' . $checked . '>';
                    echo '<label for="crosssync_website_' . esc_attr($crosssync_key) . '">' . esc_html($crosssync_value) . '</label>';
                    echo '<br/>';
                }
            } else {
                _e('Please add website in <b>CrossSync</b>. So you can select the website for sync post.', 'crosssync');
                echo "<br/>";
            }

            echo "<br/>";
            echo '<div class="meta_description"><p>' . __('select which website you want to add/edit post with this post.', 'crosssync') . '</p></div>';
            echo '</div><!-- end inner -->';
            echo '</div><!-- end single meta -->';
            echo '</div><!-- end meta container --><br />';
        }

        function save_meta_fields($post_id)
        {
            if (isset($_REQUEST['crosssync_website']) && !empty($_REQUEST['crosssync_website'])) {
                $crosssync_websites = array();
                foreach ($_REQUEST['crosssync_website'] as $crosssync_webkey => $crosssync_webvalue) {
                    $crosssync_websites[$crosssync_webkey] = esc_url_raw($crosssync_webvalue);
                }
                update_post_meta($post_id, 'crosssync_website', $crosssync_websites);
            }
        }
    }

    global $crosssync_post_meta;
    $crosssync_post_meta = new crosssync_Post_Meta();
}
