<?php
global $crosssync, $crosssync_settings;

echo "<style>
/* General Styles */
.wrap.crosssync_content {
    padding: 20px;
    background-color: #f9f9f9;
    border-radius: 8px;
}

form#crosssync_settings {
    margin: 0 auto;
    max-width: 960px;
    background-color: #fff;
    padding: 20px;
    border: 1px solid #ddd;
    border-radius: 8px;
}

/* Table and Form Styling */
.cmrc-table {
    width: 100%;
}

.setting-general h2 {
    font-size: 20px;
    color: #333;
    margin-bottom: 15px;
}

form#crosssync_settings table {
    width: 100%;
    border-collapse: collapse;
    margin-bottom: 20px;
}

form#crosssync_settings th {
    text-align: left;
    padding: 10px;
    font-weight: bold;
    color: #333;
}

form#crosssync_settings td {
    padding: 10px;
    vertical-align: top;
}

form#crosssync_settings .crosssync_input,
form#crosssync_settings .crosssync_select,
form#crosssync_settings .crosssync_checkbox {
    width: 100%;
    padding: 8px;
    margin-top: 5px;
    font-size: 14px;
    border: 1px solid #ccc;
    border-radius: 4px;
}

form#crosssync_settings .crosssync_input:focus,
form#crosssync_settings .crosssync_select:focus {
    border-color: #0073aa;
    outline: none;
}

form#crosssync_settings .crosssync_checkbox {
    width: auto;
    display: inline-block;
    margin-right: 10px;
}

form#crosssync_settings .crosssync_radio {
    width: auto;
    display: inline-block;
    margin-right: 10px;
}

/* Links and Buttons */
a.remove_site {
    color: #d9534f;
    font-weight: bold;
    text-decoration: none;
}

a.remove_site:hover {
    text-decoration: underline;
}

.add_more_site input {
    padding: 10px 20px;
    background-color: #0073aa;
    color: #fff;
    border: none;
    border-radius: 5px;
    cursor: pointer;
}

.add_more_site input:hover {
    background-color: #005f8d;
}

/* Password Visibility */
.crosssync_password_box {
    position: relative;
}

.crosssync_password_box input {
    width: calc(100% - 30px);
    display: inline-block;
}

.crosssync_show_pass,
.crosssync_hide_pass {
    position: absolute;
    top: 50%;
    right: 10px;
    transform: translateY(-50%);
    cursor: pointer;
}

.dashicons-visibility,
.dashicons-hidden {
    font-size: 16px;
}

/* Notices */
#message.updated {
    background-color: #e6f7ff;
    border-left: 4px solid #0073aa;
    padding: 10px;
    margin-bottom: 20px;
    font-size: 16px;
}

#message.updated p {
    margin: 0;
}

#message.updated .notice-dismiss {
    background: transparent;
    border: none;
    font-size: 14px;
}

#message.updated .notice-dismiss:hover {
    color: #0073aa;
}

/* Responsive Styles */
@media (max-width: 768px) {
    .wrap.crosssync_content {
        padding: 10px;
    }

    form#crosssync_settings {
        padding: 15px;
    }

    .add_more_site input {
        width: 100%;
    }
}

</style>";

if (isset($_REQUEST['crosssync_setting_save']) && isset($_REQUEST['crosssync_setting']) && $_REQUEST['crosssync_setting'] != '') {
    do_action('crosssync_save_settings', $_POST);
}

echo '<div class="wrap crosssync_content">';

if (isset($_SESSION['crosssync_msg_status']) && $_SESSION['crosssync_msg_status']) {
    echo '<div id="message" class="updated notice notice-success is-dismissible">';
    echo '<p>';
    echo (isset($_SESSION['crosssync_msg']) && $_SESSION['crosssync_msg'] != '') ? $_SESSION['crosssync_msg'] : 'Something went wrong. Please try again';
    echo '</p>';
    echo '<button type="button" class="notice-dismiss"><span class="screen-reader-text">' . __('Dismiss this notice.', 'crosssync') . '</span></button>';
    echo '</div>';
    unset($_SESSION['crosssync_msg_status']);
    unset($_SESSION['crosssync_msg']);
}

echo '<form name="crosssync_settings" id="crosssync_settings" method="post" >';

global $crosssync, $crosssync_settings;

wp_nonce_field('crosssync_nonce', 'crosssync_general_option_field');
$general_option = $crosssync_settings->crosssync_get_settings_func();
if (!empty($general_option)) {
    $total_record = count($general_option['crosssync_host_name']);
    $spcn = 0;

    echo '<div class="cmrc-table">';
    echo '<div class="setting-general" >';
    echo '<h1>CrossSync</h1>';
    echo '<h2>' . __('General options', 'crosssync') . '</h2>';
    foreach ($general_option['crosssync_host_name'] as $crosssync_key => $crosssync_value) {

        $crosssync_host_name      = ($crosssync_value) ? $crosssync_value : '';
        $crosssync_strict_mode    = isset($general_option['crosssync_strict_mode'][$crosssync_key]) ? $general_option['crosssync_strict_mode'][$crosssync_key] : 1;
        $crosssync_content_match  = isset($general_option['crosssync_content_match'][$crosssync_key]) ? $general_option['crosssync_content_match'][$crosssync_key] : 'title';
        $crosssync_roles_allowed  = isset($general_option['crosssync_roles_allowed'][$crosssync_key]) ? $general_option['crosssync_roles_allowed'][$crosssync_key] : array();
        $crosssync_contributor    = isset($crosssync_roles_allowed['roles']['contributor']) ? $crosssync_roles_allowed['roles']['contributor'] : '';
        $crosssync_author         = isset($crosssync_roles_allowed['roles']['author']) ? $crosssync_roles_allowed['roles']['author'] : '';
        $crosssync_editor         = isset($crosssync_roles_allowed['roles']['editor']) ? $crosssync_roles_allowed['roles']['editor'] : '';
        $crosssync_selected       = isset($general_option['crosssync_selected'][$crosssync_key]) ? $general_option['crosssync_selected'][$crosssync_key] : '';
        $crosssync_content_username  = isset($general_option['crosssync_content_username'][$crosssync_key]) ? $general_option['crosssync_content_username'][$crosssync_key] : '';
        $crosssync_content_password  = isset($general_option['crosssync_content_password'][$crosssync_key]) ? $general_option['crosssync_content_password'][$crosssync_key] : '';
?>
        <div class="remove_site_<?php echo $spcn; ?>">
            <table class="form-table crosssync-setting-form count_table">
                <tbody>
                    <tr>
                        <th><label for="crosssync_host_name_<?php echo $spcn; ?>"><?php _e('Host Name of Target', 'crosssync'); ?></label></th>
                        <td>
                            <input type="text" name="crosssync_host_name[<?php echo $spcn; ?>]" id="crosssync_host_name_<?php echo $spcn; ?>" class="crosssync_input crosssync_url" value="<?php echo sanitize_url($crosssync_host_name) ?>" />
                            <?php if ($spcn != 0) { ?>
                                <a href="javascript:;" class="remove_site" data-site_id="<?php echo $spcn; ?>"> Remove Site </a>
                            <?php } ?>
                            <p><?php _e('https://example.com - This is the URL that your Content will be Pushed to. If WordPress is installed in a subdirectory, include the subdirectory.', 'crosssync'); ?></p>
                        </td>
                    </tr>
                    <tr>
                        <th><label for="crosssync_content_username_<?php echo $spcn; ?>"><?php _e('Username', 'crosssync'); ?></label></th>
                        <td>
                            <input type="text" name="crosssync_content_username[<?php echo $spcn; ?>]" id="crosssync_content_username_<?php echo $spcn; ?>" class="crosssync_input" value="<?php echo sanitize_user($crosssync_content_username) ?>" />
                            <p><?php _e('Enter', 'crosssync'); ?> <span class="crosssync_username"></span> <?php _e('website username', 'crosssync'); ?></p>
                        </td>
                    </tr>
                    <tr>
                        <th><label for="crosssync_content_password_<?php echo $spcn; ?>"><?php _e('Password', 'crosssync'); ?></label></th>
                        <td>
                            <div class="crosssync_password_box">
                                <input type="password" name="crosssync_content_password[<?php echo $spcn; ?>]" id="crosssync_content_password_<?php echo $spcn; ?>" class="crosssync_input" value="<?php echo wp_strip_all_tags(stripslashes($crosssync_content_password)) ?>" />
                                <span class="dashicons dashicons-visibility crosssync_show_pass"></span>
                                <span class="dashicons dashicons-hidden crosssync_hide_pass"></span>
                            </div>
                            <p><?php _e('Enter', 'crosssync'); ?> <span class="crosssync_password"></span> <?php _e('website password', 'crosssync'); ?></p>
                        </td>
                    </tr>
                    <tr>
                        <th><label for="crosssync_strict_mode_<?php echo $spcn; ?>"><?php _e('Strict Mode', 'crosssync'); ?></label></th>
                        <td>
                            <input <?php if ($crosssync_strict_mode == 1) {
                                        echo "checked='checked'";
                                    } ?> type="radio" name="crosssync_strict_mode[<?php echo $spcn; ?>]" value="1" class="crosssync_radio" id="crosssync_strict_mode_on_<?php echo $spcn; ?>">
                            <label for="crosssync_strict_mode_on_<?php echo $spcn; ?>"> <?php _e('On - WordPress and CrossSync for Content versions must match on Source and Target in order to perform operations.', 'crosssync'); ?> </label>

                            <br>

                            <input <?php if ($crosssync_strict_mode == 0) {
                                        echo "checked='checked'";
                                    } ?> type="radio" name="crosssync_strict_mode[<?php echo $spcn; ?>]" value="0" class="crosssync_radio" id="crosssync_strict_mode_off_<?php echo $spcn; ?>">
                            <label for="crosssync_strict_mode_off_<?php echo $spcn; ?>"><?php _e('Off - WordPress and CrossSync for Content versions do not need to match.', 'crosssync'); ?> </label>
                        </td>
                    </tr>
                    <tr>
                        <th><label for="crosssync_content_match_<?php echo $spcn; ?>"><?php _e('Content Match Mode', 'crosssync'); ?></label></th>
                        <td>
                            <select id="crosssync_content_match_<?php echo $spcn; ?>" name="crosssync_content_match[<?php echo $spcn; ?>]" class="crosssync_select">
                                <option <?php if ($crosssync_content_match == 'slug') {
                                            echo "selected";
                                        } ?> value="slug">Post Slug</option>
                                <?php /*<option <?php if($crosssync_content_match=='title') { echo "selected"; } ?> value="title" >Post Title</option>
                                            <option <?php if($crosssync_content_match=='title-slug') { echo "selected"; } ?> value="title-slug">Post Title, then Post Slug</option>
                                            <option <?php if($crosssync_content_match=='slug-title') { echo "selected"; } ?> value="slug-title">Post Slug, then Post Title</option> */ ?>
                            </select>
                            <p><?php _e('Post slug - Search for matching Content on Target by Post Slug only.', 'crosssync'); ?></p>
                        </td>
                    </tr>
                    <tr>
                        <th><label for="crosssync_roles_allowed_<?php echo $spcn; ?>"><?php _e('Roles Allowed to use', 'crosssync'); ?></label></th>
                        <td>
                            <input <?php if ($crosssync_contributor) {
                                        echo "checked";
                                    } ?> type="checkbox" class="crosssync_checkbox" name="crosssync_roles_allowed[<?php echo $spcn; ?>][roles][contributor]" id="crosssync_roles_contributor_<?php echo $spcn; ?>">
                            <label for="crosssync_roles_contributor_<?php echo $spcn; ?>"><?php _e('Contributor', 'crosssync'); ?></label><br>

                            <input <?php if ($crosssync_author) {
                                        echo "checked";
                                    } ?> type="checkbox" class="crosssync_checkbox" name="crosssync_roles_allowed[<?php echo $spcn; ?>][roles][author]" id="crosssync_roles_author_<?php echo $spcn; ?>">
                            <label for="crosssync_roles_author_<?php echo $spcn; ?>"><?php _e('Author', 'crosssync'); ?></label><br>

                            <input <?php if ($crosssync_editor) {
                                        echo "checked";
                                    } ?> type="checkbox" class="crosssync_checkbox" name="crosssync_roles_allowed[<?php echo $spcn; ?>][roles][editor]" id="crosssync_roles_editor_<?php echo $spcn; ?>">
                            <label for="crosssync_roles_editor_<?php echo $spcn; ?>"><?php _e('Editor', 'crosssync'); ?></label><br>

                            <input type="checkbox" class="crosssync_checkbox" name="crosssync_roles_allowed[<?php echo $spcn; ?>][roles][administrator]" checked="checked" id="crosssync_roles_administrator_<?php echo $spcn; ?>" disabled="disabled">
                            <label for="crosssync_roles_administrator_<?php echo $spcn; ?>"><?php _e('Administrator', 'crosssync'); ?></label><br>

                            <p><?php _e('Select the Roles you wish to have access to the CrossSync User Interface. Only these Roles will be allowed to perform Syncing operations.', 'crosssync'); ?></p>
                        </td>
                    </tr>
                    <tr>
                        <th><label for="crosssync_selected_<?php echo $spcn; ?>"><?php _e('By Default Selected', 'crosssync'); ?></label></th>
                        <td>
                            <input <?php if ($crosssync_selected) {
                                        echo "checked";
                                    } ?> type="checkbox" class="crosssync_checkbox" name="crosssync_selected[<?php echo $spcn; ?>]" id="crosssync_selected_<?php echo $spcn; ?>" />
                            <label for="crosssync_selected_<?php echo $spcn; ?>"><?php _e('Site will be auto selected on Add/Edit Posts', 'crosssync'); ?></label><br>
                        </td>
                    </tr>
                </tbody>
            </table>
            <hr />
        </div>
<?php
        $spcn++;
    }

    echo '<input type="hidden" id="auto_increment" value="' . $spcn . '">';
    echo '</div>';
    echo '</div>';
}
?>

<script id="crosssync_setting_table" type="text/html">
    <div class="remove_site_{crosssync_no}">
        <table class="form-table crosssync-setting-form count_table">
            <tbody>
                <tr>
                    <th><label for="crosssync_host_name_{crosssync_no}"><?php _e('Host Name of Target', 'crosssync'); ?></label></th>
                    <td>
                        <input type="text" name="crosssync_host_name[{crosssync_no}]" id="crosssync_host_name_{crosssync_no}" class="crosssync_input crosssync_url" />
                        <a href="javascript:;" class="remove_site" data-site_id="{crosssync_no}"><?php _e(' Remove Site ', 'crosssync'); ?></a>
                        <p><?php _e('https://example.com - This is the URL that your Content will be Pushed to. If WordPress is installed in a subdirectory, include the subdirectory.', 'crosssync'); ?></p>
                    </td>
                </tr>
                <tr>
                    <th><label for="crosssync_content_username_{crosssync_no}"><?php _e('Username', 'crosssync'); ?></label></th>
                    <td>
                        <input type="text" name="crosssync_content_username[{crosssync_no}]" id="crosssync_content_username_{crosssync_no}" class="crosssync_input" value="" />
                        <p><?php _e('Enter', 'crosssync'); ?> <span class="crosssync_username"></span> <?php _e('website username', 'crosssync'); ?></p>
                    </td>
                </tr>
                <tr>
                    <th><label for="crosssync_content_password_{crosssync_no}"><?php _e('Password', 'crosssync'); ?></label></th>
                    <td>
                        <div class="crosssync_password_box">
                            <input type="password" name="crosssync_content_password[{crosssync_no}]" id="crosssync_content_password_{crosssync_no}" class="crosssync_input" value="" />
                            <span class="dashicons dashicons-visibility crosssync_show_pass"></span>
                            <span class="dashicons dashicons-hidden crosssync_hide_pass"></span>
                        </div>
                        <p><?php _e('Enter', 'crosssync'); ?> <span class="crosssync_password"></span> <?php _e('website password', 'crosssync'); ?></p>
                    </td>
                </tr>
                <tr>
                    <th><label for="crosssync_strict_mode_{crosssync_no}"><?php _e('Strict Mode', 'crosssync'); ?></label></th>
                    <td>
                        <input type="radio" name="crosssync_strict_mode[{crosssync_no}]" value="1" class="crosssync_radio" id="crosssync_strict_mode_on_{crosssync_no}" checked="checked">
                        <label for="crosssync_strict_mode_on_{crosssync_no}"><?php _e('On - WordPress and CrossSync for Content versions must match on Source and Target in order to perform operations.', 'crosssync'); ?></label>
                        <br>

                        <input type="radio" name="crosssync_strict_mode[{crosssync_no}]" value="0" class="crosssync_radio" id="crosssync_strict_mode_off_{crosssync_no}">
                        <label for="crosssync_strict_mode_off_{crosssync_no}"><?php _e('Off - WordPress and CrossSync for Content versions do not need to match.', 'crosssync'); ?></label>
                    </td>
                </tr>
                <tr>
                    <th><label for="crosssync_content_match_{crosssync_no}"><?php _e('Content Match Mode', 'crosssync'); ?></label></th>
                    <td>
                        <select id="crosssync_content_match_{crosssync_no}" name="crosssync_content_match[{crosssync_no}]" class="crosssync_select">
                            <option value="slug"><?php _e('Post Slug', 'crosssync'); ?></option>
                            <?php /*<option value="title" selected="selected"><?php _e('Post Title', 'crosssync'); ?></option>
                                <option value="title-slug"><?php _e('Post Title, then Post Slug', 'crosssync'); ?></option>
                                <option value="slug-title"><?php _e('Post Slug, then Post Title', 'crosssync'); ?></option> */ ?>
                        </select>
                        <p><?php _e('Post slug - Search for matching Content on Target by Post slug only.', 'crosssync'); ?></p>
                    </td>
                </tr>
                <tr>
                    <th><label for="crosssync_roles_allowed_{crosssync_no}"><?php _e('Roles Allowed to use', 'crosssync'); ?></label></th>
                    <td>
                        <input type="checkbox" class="crosssync_checkbox" name="crosssync_roles_allowed[{crosssync_no}][roles][contributor]" id="crosssync_roles_contributor_{crosssync_no}">
                        <label for="crosssync_roles_contributor_{crosssync_no}"><?php _e('Contributor', 'crosssync'); ?></label><br>
                        <input type="checkbox" class="crosssync_checkbox" name="crosssync_roles_allowed[{crosssync_no}][roles][author]" id="crosssync_roles_author_{crosssync_no}" checked="checked">
                        <label for="crosssync_roles_author_{crosssync_no}"><?php _e('Author', 'crosssync'); ?></label><br>
                        <input type="checkbox" class="crosssync_checkbox" name="crosssync_roles_allowed[{crosssync_no}][roles][editor]" id="crosssync_roles_editor_{crosssync_no}" checked="checked">
                        <label for="crosssync_roles_editor_{crosssync_no}"><?php _e('Editor', 'crosssync'); ?></label><br>
                        <input type="checkbox" class="crosssync_checkbox" name="crosssync_roles_allowed[{crosssync_no}][roles][administrator]" id="crosssync_roles_administrator_{crosssync_no}" checked="checked" disabled="disabled">
                        <label for="crosssync_roles_administrator_{crosssync_no}"><?php _e('Administrator', 'crosssync'); ?></label><br>

                        <p><?php _e('Select the Roles you wish to have access to the CrossSync User Interface. Only these Roles will be allowed to perform Syncing operations.', 'crosssync'); ?></p>
                    </td>
                </tr>
                <tr>
                    <th><label for="crosssync_selected_{crosssync_no}"><?php _e('By Default Selected', 'crosssync'); ?></label></th>
                    <td>
                        <input <?php if ($crosssync_selected) {
                                    echo "checked";
                                } ?> type="checkbox" class="crosssync_checkbox" name="crosssync_selected[{crosssync_no}]" id="crosssync_selected_{crosssync_no}">
                        <label for="crosssync_selected_{crosssync_no}"><?php _e('Site will be auto selected on Add/Edit Posts', 'crosssync'); ?></label><br>
                    </td>
                </tr>
            </tbody>
        </table>
        <hr />
    </div>
</script>
<?php
echo '<p class="add_more_site">';
echo '<input type="button" name="add_more_site" class="button-primary " value="Add more site" >';
echo '</p>';

echo '<p class="submit">';
echo '<input type="hidden" name="crosssync_setting" id="crosssync_setting" value="crosssync_setting" />';
echo '<input name="crosssync_setting_save" class="button-primary crosssync_setting_save" type="submit" value="Save changes" />';
echo '</p>';

echo '</form>';
echo '</div>';
