<?php

if (!class_exists('crosssync_Sync')) {

    class crosssync_Sync
    {

        var $is_website_post = true;

        var $post_old_title = '';



        function __construct()
        {



            add_filter('wp_insert_post_data', array($this, 'filter_post_data'), '99', 2);



            // save tags to post for guttenburg because save post not get the tags in guttenburg.

            add_action("rest_insert_post", array($this, "crosssync_rest_insert_post"), 10, 3);



            add_action("save_post", array($this, "crosssync_save_post"), 10, 3);



            add_action("crosssyncp_after_save_data", array($this, "crosssyncp_grab_content_images"), 10, 2);



            add_action('rest_api_init', array($this, 'rest_api_init_func')); // Register custom API endpoints

        }





        function rest_api_init_func()
        {

            register_rest_route('crosssync/v1', '/data', array(

                'methods'  => 'POST',

                'callback' => array($this, 'crosssync_get_request'),

            ));
        }



        function filter_post_data($data, $postarr)
        {

            global $post_old_title;

            if (isset($postarr['ID']) && !empty($postarr['ID'])) {

                $old_data = get_posts(array('ID' => $postarr['ID']));

                if ($old_data && isset($old_data[0]->post_title) && $postarr != $old_data[0]->post_title) {

                    $post_old_title = $old_data[0]->post_title;
                }
            }



            return $data;
        }



        function crosssync_rest_insert_post($post, $reqest, $creating)
        {

            $json = $reqest->get_json_params();

            if (isset($json['tags']) && !empty($json['tags'])) {

                $this->crosssync_save_post($post->ID, $post, 1, $json['tags']);
            }
        }



        function crosssync_send_data_to($action, $args = array(), $crosssync_website = array())
        {

            global $wpdb, $crosssync, $crosssync_settings, $post_old_title;

            $general_option = $crosssync_settings->crosssync_get_settings_func();



            if (!empty($general_option) && isset($general_option['crosssync_host_name']) && !empty($general_option['crosssync_host_name'])) {

                foreach ($general_option['crosssync_host_name'] as $crosssync_key => $crosssync_value) {



                    $args['crosssync']['roles'] = isset($general_option['crosssync_roles_allowed'][$crosssync_key]['roles']) ? $general_option['crosssync_roles_allowed'][$crosssync_key]['roles'] : array();

                    $args['crosssync']['host_name']   = !empty($crosssync_value) ? $crosssync_value : '';

                    $args['crosssync']['strict_mode'] = isset($general_option['crosssync_strict_mode'][$crosssync_key]) ? $general_option['crosssync_strict_mode'][$crosssync_key] : 1;

                    $args['crosssync']['roles']['administrator'] = 'on';



                    $args['crosssync']['content_match'] = isset($general_option['crosssync_content_match'][$crosssync_key]) ? $general_option['crosssync_content_match'][$crosssync_key] : 'title';

                    $args['crosssync']['content_username'] = isset($general_option['crosssync_content_username'][$crosssync_key]) ? $general_option['crosssync_content_username'][$crosssync_key] : '';

                    $args['crosssync']['content_password'] = isset($general_option['crosssync_content_password'][$crosssync_key]) ? $general_option['crosssync_content_password'][$crosssync_key] : '';



                    if (isset($args['post_content']) && isset($args['crosssync']['strict_mode']) && $args['crosssync']['strict_mode']) {

                        $args['post_content'] = addslashes($args['post_content']);
                    } else {

                        $args['post_content'] = do_shortcode($args['post_content']);
                    }



                    $loggedin_user_role = wp_get_current_user();

                    $matched_role = array_intersect($loggedin_user_role->roles, array_keys($args['crosssync']['roles']));



                    if (!empty($crosssync_value) && !empty($matched_role) && in_array($crosssync_value, $crosssync_website)) {

                        return $this->crosssync_remote_post($action, $args);
                    }
                }
            }
        }



        function crosssync_remote_post($action, $args = array())
        {

            do_action('crosssyncp_before_send_data', $args);

            $args['crosssync_action'] = $action;

            $url = $args['crosssync']['host_name'] . "/wp-json/crosssync/v1/data";

            $return = wp_remote_post($url, array('body' => $args));

            return $return;
        }



        function crosssync_save_post($post_ID, $post, $update, $tagids = '')
        {

            if (defined('DOING_AUTOSAVE') && DOING_AUTOSAVE) {
                return;
            }

            $crosssync_website = isset($_REQUEST['crosssync_website']) ? $_REQUEST['crosssync_website'] : array();

            $status_not = array('auto-draft', 'trash', 'inherit', 'draft');

            if ($this->is_website_post && isset($post->post_status) && !in_array($post->post_status, $status_not) && !empty($crosssync_website)) {



                global $wpdb, $crosssync, $crosssync_settings, $post_old_title;

                $args = (array) $post;

                if (!empty($post_old_title)) {

                    $args['post_old_title'] = $post_old_title;
                } else {

                    $args['post_old_title'] = $args['post_title'];
                }



                if (has_post_thumbnail($post_ID)) {

                    $args['featured_image'] = get_the_post_thumbnail_url($post_ID);
                }



                if (!empty($post->post_parent)) {

                    $args['post_parent_slug'] = get_post_field("post_name", $post->post_parent);
                }



                $taxonomies = get_object_taxonomies($args['post_type']);

                if (!empty($taxonomies)) {

                    $taxonomies_data = array();

                    foreach ($taxonomies as $taxonomy) {

                        $taxonomies_data[$taxonomy] = wp_get_post_terms($post_ID, $taxonomy);
                    }

                    $args['taxonomies'] = $taxonomies_data;
                }



                $post_metas = get_post_meta($post_ID);

                // MY code Start
                if (isset($_POST['my_downloadlinks_title']) && !empty($_POST['my_downloadlinks_title'])) {
                    $my_downloadlinks_array = array();
                    $my_downloadlinks_title = array_map('sanitize_text_field', $_POST['my_downloadlinks_title']);
                    $my_downloadlinks_url = array_map('sanitize_text_field', $_POST['my_downloadlinks_url']);
                    $my_downloadlinks_lang = array_map('sanitize_text_field', $_POST['my_downloadlinks_lang']);
                    $my_downloadlinks_quality = array_map('sanitize_text_field', $_POST['my_downloadlinks_quality']);

                    foreach ($my_downloadlinks_title as $key => $my_downloadlinks_title) {
                        $my_downloadlinks_array[] = array(
                            'title' => $my_downloadlinks_title,
                            'url' => $my_downloadlinks_url[$key],
                            'lang' => $my_downloadlinks_lang[$key],
                            'quality' => $my_downloadlinks_quality[$key],
                        );
                    }
                    if ($my_downloadlinks_array[0]['title'] != "") {
                        $json_data = wp_json_encode($my_downloadlinks_array);
                        $post_metas['_mydownloadlinks'][0] = $json_data;
                    }
                } else {
                    $post_metas['_mydownloadlinks'][0] = "";
                }
                // MY code End
                error_log("Download Links", print_r($post_metas, true));

                if (!empty($post_metas)) {

                    foreach ($post_metas as $meta_key => $meta_value) {

                        if ($meta_key != 'crosssync_website') {

                            $args['meta'][$meta_key] = isset($meta_value['0']) ? maybe_unserialize($meta_value['0']) : '';
                        }
                    }
                }

                $response = $this->crosssync_send_data_to('add_update_post', $args, $crosssync_website);

                if (is_array($response)) {

                    if (isset($response['response']['code']) && $response['response']['code'] == 200) {

                        $other_site_post_id = $response['body'];
                    }
                }
            }
        }



        function crosssync_check_data($content_mach, $post_data)
        {



            global $wpdb;



            $the_slug = $post_data['post_name'];

            $the_title = isset($post_data['post_old_title']) ? $post_data['post_old_title'] : '';



            $args_title = array(

                'title'        => $the_title,

                'post_type'   => $post_data['post_type']

            );

            $args_slug = array(

                'name'        => $the_slug,

                'post_type'   => $post_data['post_type']

            );



            $post_id = '';

            if ($content_mach == "title") {

                $my_posts = get_posts($args_title);

                if ($my_posts) {

                    $post_id = $my_posts[0]->ID;
                }
            } else if ($content_mach == "title-slug") {

                $my_posts = get_posts($args_title);

                if ($my_posts) {

                    $post_id = $my_posts[0]->ID;
                } else {

                    $my_posts2 = get_posts($args_slug);

                    if ($my_posts2) {

                        $post_id = $my_posts2[0]->ID;
                    }
                }
            } else if ($content_mach == "slug") {

                $my_posts = get_posts($args_slug);

                if ($my_posts) {

                    $post_id = $my_posts[0]->ID;
                }
            } else if ($content_mach == "slug-title") {

                $my_posts = get_posts($args_slug);

                if ($my_posts) {

                    $post_id = $my_posts[0]->ID;
                } else {

                    $my_posts = get_posts($args_title);

                    if ($my_posts) {

                        $post_id = $my_posts[0]->ID;
                    }
                }
            }



            return $post_id;
        }



        function grab_image($url, $saveto)
        {



            $data = wp_remote_request($url);



            if (isset($data['body']) && isset($data['response']['code']) && !empty($data['response']['code'])) {

                $raw = $data['body'];

                if (file_exists($saveto)) {

                    wp_delete_file($saveto);
                }

                $fp = fopen($saveto, 'x');

                fwrite($fp, $raw);

                fclose($fp);
            }
        }



        function crosssync_custom_wpkses_post_tags($tags, $context)
        {

            if ('post' === $context) {

                $tags['iframe'] = array(

                    'src'             => true,

                    'height'          => true,

                    'width'           => true,

                    'frameborder'     => true,

                    'allowfullscreen' => true,

                );



                $tags['embed'] = array(

                    'type'   => true,

                    'src'    => true,

                    'height' => true,

                    'width'  => true,

                );
            }



            return $tags;
        }



        function crosssync_add_update_post($author, $crosssync_sync_data)
        {



            $return = array();

            $crosssync_sync_data['post_author'] = $author->ID;

            $post_id = $this->crosssync_check_data($crosssync_sync_data['content_match'], $crosssync_sync_data);

            $crosssync_sync_data['post_content'] = stripslashes($crosssync_sync_data['post_content']);



            if (!empty($crosssync_sync_data['post_parent']) && !empty($crosssync_sync_data['post_parent_slug'])) {

                $parent_post_arg = array(

                    'name'        => $crosssync_sync_data['post_parent_slug'],

                    'post_type'   => $crosssync_sync_data['post_type']

                );



                $parent_post = get_posts($parent_post_arg);

                if ($parent_post) {

                    $crosssync_sync_data['post_parent'] = $parent_post[0]->ID;
                }
            }



            // For allow some content tags like iframe

            add_filter('wp_kses_allowed_html', array($this, 'crosssync_custom_wpkses_post_tags'), 10, 2);



            $post_action = '';

            if (!empty($post_id)) {

                $post_action = 'edit';

                $crosssync_sync_data['ID'] = $post_id;

                $post_id = wp_update_post($crosssync_sync_data);
            } else {

                $post_action = 'add';

                $post_id = wp_insert_post($crosssync_sync_data);
            }



            // For remove some content tags like iframe which are allowed above.

            remove_filter('wp_kses_allowed_html', array($this, 'crosssync_custom_wpkses_post_tags'), 10, 2);



            if (isset($crosssync_sync_data['taxonomies']) && !empty($crosssync_sync_data['taxonomies'])) {

                foreach ($crosssync_sync_data['taxonomies'] as $taxonomy => $texonomy_data) {

                    if (is_taxonomy_hierarchical($taxonomy)) {

                        // For hierarchical taxonomy - Categories

                        if (isset($texonomy_data) && !empty($texonomy_data)) {

                            $post_categories = array();

                            foreach ($texonomy_data as $category) {

                                $term = term_exists($category['name'], $taxonomy);

                                if ($term) {

                                    $post_categories[] = $term['term_id'];
                                } else {

                                    $tag_temp = wp_insert_term($category['name'], $taxonomy);

                                    $tag_id = $tag_temp['term_id'];

                                    $post_categories[] = $tag_id;
                                }
                            }

                            wp_set_post_terms($post_id, $post_categories, $taxonomy, false);
                        } else {

                            wp_set_post_terms($post_id);
                        }
                    } else {

                        // For non-hierarchical taxonomy - Tags

                        if (isset($texonomy_data) && !empty($texonomy_data)) {

                            $post_tags = array();

                            foreach ($texonomy_data as $tag) {

                                $post_tags[] = $tag['name'];
                            }

                            wp_set_post_terms($post_id, $post_tags, $taxonomy, false);
                        } else {

                            wp_set_post_terms($post_id);
                        }
                    }
                }
            }



            if (isset($crosssync_sync_data['meta']) && !empty($crosssync_sync_data['meta'])) {

                foreach ($crosssync_sync_data['meta'] as $meta_key => $meta_value) {

                    update_post_meta($post_id, $meta_key, $meta_value);
                }
            }



            if (isset($crosssync_sync_data['featured_image']) && !empty($crosssync_sync_data['featured_image'])) {



                $image_url        = $crosssync_sync_data['featured_image'];

                $image_arr        = explode('/', $crosssync_sync_data['featured_image']);

                $image_name       = end($image_arr);

                $upload_dir       = wp_upload_dir();

                $unique_file_name = wp_unique_filename($upload_dir['path'], $image_name);

                $filename         = basename($unique_file_name);



                // Check folder permission and define file location

                if (wp_mkdir_p($upload_dir['path'])) {

                    $file = $upload_dir['path'] . '/' . $filename;
                } else {

                    $file = $upload_dir['basedir'] . '/' . $filename;
                }



                // Create the image  file on the server

                $this->grab_image($image_url, $file);



                // Check image file type

                $wp_filetype = wp_check_filetype($filename, null);



                // Set attachment data

                $attachment = array(

                    'post_mime_type' => $wp_filetype['type'],

                    'post_title'     => sanitize_file_name($filename),

                    'post_content'   => '',

                    'post_status'    => 'inherit'

                );



                // Create the attachment

                $attach_id = wp_insert_attachment($attachment, $file, $post_id);



                // Include image.php

                require_once(ABSPATH . 'wp-admin/includes/image.php');



                // Define attachment metadata

                $attach_data = wp_generate_attachment_metadata($attach_id, $file);



                // Assign metadata to attachment

                wp_update_attachment_metadata($attach_id, $attach_data);



                // And finally assign featured image to post

                $data = set_post_thumbnail($post_id, $attach_id);
            }



            do_action('crosssyncp_after_save_data', $post_id, $crosssync_sync_data);



            $return['status'] = __('success', 'crosssync');

            $return['msg'] = __('Data proccessed successfully', 'crosssync');

            $return['post_id'] = $post_id;

            $return['post_action'] = $post_action;

            return $return;
        }



        function crosssync_get_request($request)
        {

            $crosssync_sync_data = $request->get_params();

            if (isset($crosssync_sync_data['crosssync_action']) && !empty($crosssync_sync_data['crosssync_action'])) {

                $this->is_website_post = false;

                $crosssync_host_name        = isset($crosssync_sync_data['crosssync']['host_name']) ? esc_url_raw($crosssync_sync_data['crosssync']['host_name']) : '';

                $crosssync_content_username = isset($crosssync_sync_data['crosssync']['content_username']) ? sanitize_text_field($crosssync_sync_data['crosssync']['content_username']) : '';

                $crosssync_content_password = isset($crosssync_sync_data['crosssync']['content_password']) ? sanitize_text_field($crosssync_sync_data['crosssync']['content_password']) : '';

                $crosssync_strict_mode      = isset($crosssync_sync_data['crosssync']['strict_mode']) ? sanitize_text_field($crosssync_sync_data['crosssync']['strict_mode']) : '';

                $crosssync_content_match    = isset($crosssync_sync_data['crosssync']['content_match']) ? sanitize_text_field($crosssync_sync_data['crosssync']['content_match']) : '';

                $crosssync_roles            = isset($crosssync_sync_data['crosssync']['roles']) ? sanitize_text_field($crosssync_sync_data['crosssync']['roles']) : '';

                $crosssync_action           = isset($crosssync_sync_data['crosssync_action']) ? 'crosssync_' . sanitize_text_field($crosssync_sync_data['crosssync_action']) : '';

                unset($crosssync_sync_data['crosssync']);

                $return = array();

                if (!empty($crosssync_content_username) && !empty($crosssync_content_password)) {

                    $author = wp_authenticate($crosssync_content_username, $crosssync_content_password);

                    if (isset($author->ID) && !empty($author->ID)) {



                        unset($crosssync_sync_data['crosssync']);

                        unset($crosssync_sync_data['crosssync_action']);



                        if (isset($crosssync_sync_data['ID'])) {

                            unset($crosssync_sync_data['ID']);
                        }



                        if ($crosssync_action == 'crosssync_authenticate') {

                            $return['status'] = __('success', 'crosssync');

                            $return['msg'] = __('Authenitcate successfully.', 'crosssync');
                        } else {

                            $crosssync_sync_data['content_match'] = $crosssync_content_match;

                            $return = call_user_func(array($this, $crosssync_action), $author, $crosssync_sync_data);
                        }
                    } else {

                        $return['status'] = __('failed', 'crosssync');

                        $return['msg'] = __('Authenitcate failed.', 'crosssync');
                    }
                } else {

                    $return['status'] = __('failed', 'crosssync');

                    $return['msg'] = __('Username or Password is null.', 'crosssync');
                }



                return new WP_REST_Response($return, 200);
            }
        }



        function crosssyncp_grab_content_images($post_id, $crosssync_sync_data)
        {

            $post_content = stripslashes($crosssync_sync_data['post_content']);

            preg_match_all('/<img[^>]+>/i', $post_content, $images_tag);



            if (isset($images_tag[0]) && !empty($images_tag[0])) {

                foreach ($images_tag[0] as $img_tag) {

                    preg_match_all('/(alt|title|src)=("[^"]*")/i', $img_tag, $img_data);

                    if (isset($img_data[2][0]) && !empty($img_data[2][0]) && isset($img_data[1][0]) && $img_data[1][0] == 'src') {

                        $image_url = str_replace('"', '', $img_data[2][0]);



                        // check image is exists

                        $args = array(

                            'post_type' => 'attachment',

                            'post_status' => 'inherit',

                            'meta_query' => array(

                                array(

                                    'key'       => 'old_site_url',

                                    'value'     => $image_url,

                                    'compare'   => '='

                                ),

                            ),

                        );



                        $attachment = new WP_Query($args);



                        if (empty($attachment->posts)) {



                            $image_arr        = explode('/', $image_url);

                            $image_name       = end($image_arr);

                            $upload_dir       = wp_upload_dir();

                            $unique_file_name = wp_unique_filename($upload_dir['path'], $image_name);

                            $filename         = basename($unique_file_name);



                            // Check folder permission and define file location

                            if (wp_mkdir_p($upload_dir['path'])) {

                                $file = $upload_dir['path'] . '/' . $filename;
                            } else {

                                $file = $upload_dir['basedir'] . '/' . $filename;
                            }



                            // Create the image  file on the server

                            $this->grab_image($image_url, $file);



                            // Check image file type

                            $wp_filetype = wp_check_filetype($filename, null);



                            // Set attachment data

                            $attachment = array(

                                'post_mime_type' => $wp_filetype['type'],

                                'post_title'     => sanitize_file_name($filename),

                                'post_content'   => $image_url,

                                'post_status'    => 'inherit'

                            );



                            $attach_id = wp_insert_attachment($attachment, $file, $post_id);

                            update_post_meta($attach_id, 'old_site_url', $image_url);
                        } else {

                            $attachment_posts = $attachment->posts;

                            $attach_id = $attachment_posts[0]->ID;
                        }



                        $new_image_url = wp_get_attachment_url($attach_id);

                        $post_content = str_replace($image_url, $new_image_url, $post_content);
                    }
                }



                wp_update_post(array('ID' => $post_id, 'post_content' => $post_content));
            }
        }
    }



    global $crosssync_sync, $post_old_title;

    $crosssync_sync = new crosssync_Sync();
}
